import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkUsersCoupon, ThinkUsersCouponParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkUsersCoupon(params: ThinkUsersCouponParam) {
  const res = await request.get<ApiResult<PageResult<ThinkUsersCoupon>>>(
    THINK_API_URL + '/think/think-users-coupon/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkUsersCoupon(params?: ThinkUsersCouponParam) {
  const res = await request.get<ApiResult<ThinkUsersCoupon[]>>(
    THINK_API_URL + '/think/think-users-coupon',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkUsersCoupon(data: ThinkUsersCoupon) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-coupon',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkUsersCoupon(data: ThinkUsersCoupon) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-coupon',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkUsersCoupon(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-coupon/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkUsersCoupon(
  data: (number | undefined)[]
) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-users-coupon/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkUsersCoupon(id: number) {
  const res = await request.get<ApiResult<ThinkUsersCoupon>>(
    THINK_API_URL + '/think/think-users-coupon/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
